using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Web.Caching;
using System.Xml.Serialization;

namespace AbstractCache
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	[WebService(Namespace="http://localhost/dotnetpatterns/advancedpatterns/abstractcache/")]
	public class AbstractCache : System.Web.Services.WebService
	{
		public SessionHeader oSessionHeader;

		/// <summary>
		/// Session Header that will contain our session id key for the cache
		/// </summary>
		public class SessionHeader : SoapHeader
		{
			public string sSessionId;
			
		}

		public AbstractCache()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}
		#endregion

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
		}

		/// <summary>
		/// Main web method upon which to call a cachable business object
		/// This does not have to be a web service, this is optional.  If a web service or asp.net 
		/// application is not used then custom cache object should be used.
		/// </summary>
		[SoapHeaderAttribute("oSessionHeader", Direction=SoapHeaderDirection.In)]
		[WebMethod]
		public void Execute(bool bCacheObject)
		{
			if (bCacheObject)
			{
				string sKey = "defaultsessionid";
							
				// make sure a soap header was sent.
				if (oSessionHeader != null)
					sKey = oSessionHeader.sSessionId;
								
				// the cachable object will determine if, when, and how to cache himself
				// we just pass the container wrapper in our CacheAdapter and the lookup key.
				ICached oConcreteCached = (ICached) ConcreteCacheable.PrepareCache(new CacheAdapter(Context.Cache), sKey);
				
				// we are cached and prepared either way, now lets run
				oConcreteCached.ExecuteCached();
			}
			else
			{
				// interact with object normally...
				ConcreteCacheable oConcreteCacheable = new ConcreteCacheable();
				oConcreteCacheable.ExecuteWithoutCache();
			}
		}
	}
}
