using System;
using System.Collections;

namespace DotNetPatterns.Common
{
	/// <summary>
	/// 
	/// </summary>
	public class PacketCollection : System.Collections.CollectionBase
	{
		public void Add(Packet oPacket)
		{
			List.Add(oPacket);
		}

		public void Remove(int index)
		{
			// Check to see if there is a Packet at the supplied index.
			if (index > Count - 1 || index < 0)				
			{
				// No Packet exists, the operation is cancelled.
			}
			else
			{
				List.RemoveAt(index); 
			}
		}

		public Packet Item(int Index)
		{
			// The appropriate item is retrieved from the List object and
			// explicitly cast to the Packet type, then returned to the 
			// caller.
			return (Packet) List[Index];
		}
	
	}

}
