using System;
using System.Data;
using System.Xml;
using System.Runtime.Serialization;

namespace DotNetPatterns.Common
{
	/// <summary>
	/// This classes primary responsiblity is for translating Packet into DataSet and back again.
	/// At the same time this will properly hydrate important Packet properties for routing purposes. 
	/// This class implements the Abstract Packet Translator pattern using two overloaded methods to translate
	/// This class will be drive from the PMFacade base class, each descendant Facade must call PMFacade.PreparePacket()
	/// perform packet translation.
	/// </summary>
	/// <remarks>
	/// 1. For every product type (e.g. CreditCard) add the appropriate case statement if there is a 
	///    business specific data object that should be enstantiated and hydrated from the DataSet's schema
	/// </remarks>
	public class PacketTranslator
	{
		/// <summary>
		/// same ole same ole
		/// </summary>
        public PacketTranslator()
		{
		}

		/// <summary>
		/// Used to write XML contents from the incoming RawPacket (DataSet) and hydrate (fill)
		/// the strongly-typed DataSet with this schema and data.
		/// </summary>
		/// <param name="dsRawPacket"></param>
		/// <param name="oDataObject"></param>
		/// <returns></returns>
		private DataSet HydrateDataObject(DataSet dsRawPacket, DataSet oDataObject)
		{
			// if you want to use the xml to copy contents uncomment this following...
			// cannot use Copy() here or downcasting won't work on return value
			System.IO.MemoryStream stream = new System.IO.MemoryStream();
			dsRawPacket.WriteXml(new XmlTextWriter(stream, null));
			stream.Position = 0;
			oDataObject.ReadXml(new XmlTextReader(stream),XmlReadMode.IgnoreSchema);
			return oDataObject;
		}

		/// <summary>
		/// Translate from a DataSet to a Packet.  This must be edited for each product
		/// </summary>
		/// <param name="oRawPacket"></param>
		/// <returns></returns>
		public Packet Translate(object oRawPacket)
		{
			Packet oPacket = null;

			// set Data and Meta table propertis from DataSet
			return oPacket;
		}

		/// <summary>
		/// Simply translate back to a DataSet from a Packet
		/// </summary>
		/// <param name="oPacket"></param>
		/// <returns></returns>
		public object Translate(Packet oPacket)
		{
			return oPacket.RawData;
		}

		public Packet Translate(string sXML)
		{
			return null;
		}
				
	}
}
