using System;

namespace Paymetric.Server
{
	/// <summary>
	/// Summary description for IModelFactoryKeyBuilder.
	/// </summary>
	public interface IModelFactoryKeyBuilder
	{
		string GetKeyValue(long lTransID, string sKeyName);
		string GetKeyValue(object oKey);
		string[] GetAllKeyValues(long lTransID);
		
		bool StoreKey(long lTransID, string sKeyName, string sKeyValue);		
		bool StoreKey(object oKey);
		bool StoreAllKey(System.Array aKeys);
		
		bool RemoveKey(long lTransID, string sKeyName);						
		bool RemoveAllKeys(object[] aKeys);

		bool RebuildAllKeys(System.Array aKeys);

		string DoesKeyExists(long lTransID, string sKeyName);
		string DoesKeyExists(object oKey);
	}
}
