using System;
using System.Collections;
using System.Collections.Specialized;
using System.Data;

namespace Paymetric.Server
{
	/// <summary>
	/// Put something useful here!
	/// </summary>
	public interface IPMDAL
	{		
		PMPacket GetSchemaPacket(string sSchemaName);
		PMPacket GetSchemaPacket(long lSchemaID);

		string GetSchema(string sSchemaName);
		string GetSchema(long lSchemaID);
		string GetSchemaBySQL(string sSQL);
		
		bool StoreSchema(string sName, string sDescription, PMPacket oSchema);

		PMPacket GetPacket(long sTransactionID);
		PMPacket GetPacket(PMDALWhereCollection colWhere);
		
		PMPacket GetPacketBySQL(string sSQL);

		PMPacketCollection GetPacketCollection(ArrayList arlTransIDs);
		PMPacketCollection GetPacketCollection(PMDALWhereCollection colWhere);
		PMPacketCollection GetPacketCollection(long lSchemaID);	
		PMPacketCollection GetPacketCollection(long lSchemaID, PMDALWhereCollection colWhere);	

		PMPacketCollection GetPacketCollectionBySQL(string sSQL);
		
		bool StorePacket(PMPacket oPacket);		
		bool StorePacketCollection(PMPacketCollection colPackets);
		
		bool ExecuteSQL(string sSQL, ref int iProcessedRowCount);
		int ExecuteSQLCollection(StringCollection scolSQL);
		DataSet ExecuteSQLReturnDataSet(string sSQL, ref int iReturnedRowCount);
		
		long GetCounterValue(string sCounterName);		
		bool StoreCounterValue(string sCounterName, long lValue);

		long GetNextCounterValue(string sCounterName);
		long GetNextCounterValue(string sCounterName, long lDefaultValue);
		long GenerateTransactionID();

		DateTime GetCurrentDBDate();
		
		PMPacketCollection Compress(ArrayList arlTransIDs);
		PMPacketCollection Compress(PMPacketCollection colPackets);
		PMPacketCollection Compress(long lSchemaID, PMDALWhereCollection colWhere);
		PMPacketCollection CompressBySQL(string sSQL);

		PMPacketCollection Purge(ArrayList arlTransIDs);
		PMPacketCollection Purge(PMPacketCollection colPackets);
		PMPacketCollection Purge(long lSchemaID, PMDALWhereCollection colWhere);
		PMPacketCollection Purge(string sSQL);
		PMPacketCollection PurgeBySQL(string sSQL);		
	}
}
