using System;
using System.Text;
using DataTierPatterns.Data;
using System.Collections;
using System.Collections.Specialized;

namespace DataTierPatterns.Data
{
	/// <summary>
	///	PolyModelDataSQLServerWhereCollection is an implementation of the abstract class SchemaPolyModelWhereCollection that implements native .NET support for Mircosoft SQL 
	///	Server.  See SchemaPolyModelWhereCollection for more information concerning what this class has to offer.
	/// </example>
	public class MSSQLPolyModelWhereCollection : PolyModelWhereCollection
	{
		public MSSQLPolyModelWhereCollection()
		{

		}

		public override string GetSQL(long lSchemaID)
		{
			if(Count == 0)
				return string.Empty;
			
			long lWhereCount = 0;
			lWhereCount = Count;

			StringCollection colSWhere = null;
			colSWhere = new StringCollection();
		
			for(int i = 0; i < lWhereCount; i++)
			{			
				PolyModelWhere oWhere = null;
				oWhere = Item(i);
				if(oWhere == null)
					return string.Empty;

				colSWhere.Add(string.Format(DTPConfig.GetSQLText(101), oWhere.SQL));
			}		
			
			if(colSWhere.Count == 0)
				return string.Empty;

			string sWhereSchema = string.Empty;
			if(lSchemaID != 0)
				sWhereSchema = string.Format(DTPConfig.GetSQLText(102), lSchemaID);
						
			if(colSWhere.Count == 1)
				return string.Format(DTPConfig.GetSQLText(103), colSWhere[0], sWhereSchema);			

			lWhereCount = colSWhere.Count;

			string sWhere = string.Empty;

			for(int i = Convert.ToInt32(lWhereCount-1); i > -1 ; i--)
			{
				if(i == (lWhereCount-1))
					sWhere = colSWhere[i];
				else
					sWhere = string.Format(DTPConfig.GetSQLText(104), colSWhere[i], sWhere);					
			}

			sWhere = string.Format(DTPConfig.GetSQLText(105), sWhere, sWhereSchema);

			return sWhere;
		}

		public override string GetSQL()
		{
			return GetSQL(0);
		}
	}
}
