using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Reflection;
using System.Text;
using System.IO;
using Common;

namespace UnchainedServiceFactory
{
	/// <summary>
	/// 
	/// </summary>
	public class UnchainedServiceFactory : System.Web.Services.WebService
	{
		public UnchainedServiceFactory()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		[WebMethod]
		public DataSet Execute(DataSet dsData, string sService)		
		{
			DataSet ds = new DataSet();
			Assembly oAssembly = null;
			Type oServiceFacadeType = null;
			object oServiceFacade = null;
			MethodInfo oFactoryMethod = null;
			object[] oaParams = null;
			
			try
			{
				// load the assembly containing the facades
				oAssembly = Assembly.GetExecutingAssembly();

				// return the type and enstantiate the facade class based on the service name passed
				oServiceFacadeType = oAssembly.GetType(new StringBuilder("DotNetPatterns.Common")
					.Append(".")
					.Append(sService)
					.Append("Facade").ToString());
				
				oServiceFacade = Activator.CreateInstance(oServiceFacadeType);
				
				// return the factory method for the chosen facade class/type
				oFactoryMethod = oServiceFacadeType.GetMethod("Execute");
				
				// bind the parameters for the factory method - single parm in this case - dsPacket (DataSet)
				oaParams = new object[2];
				oaParams[0] = dsData;
				 
				// invoke the DoOp factory method of the chosen facade
				ds = (DataSet) oFactoryMethod.Invoke(oServiceFacade, oaParams);
			}
			catch (FileNotFoundException fe)
			{
				// need to add web service exception handling here...
				throw new BaseException(this, 100, Utilities.BuildErrorMessage("General Error", fe.Message), fe, true);
			}
			catch (Exception e)
			{
				// need to add web service exception handling here...
				throw new BaseException(this, 100, Utilities.BuildErrorMessage("General Error", e.Message), e, true);
			}
			
			return ds;
		}
	}
}
