using System;
using System.Threading;

namespace Delays
{
	/// <summary>
	/// Summary description for Factors.
	/// </summary>
	public class Factors
	{
		private int mID;
		private ulong mToFactor;
		private System.Windows.Forms.Control mControllingControl;

		public delegate void FactorCompleteEvent(int ID, ulong Factored, string Result);

		public event FactorCompleteEvent FactoringComplete;
		public System.Windows.Forms.Control ControllingControl
		{
			get { return mControllingControl; }
			set { mControllingControl = value; }
		}

		public Factors(int ID, ulong ToFactor)
		{
			mID = ID;
			mToFactor = ToFactor;
		}

		public string Factor()
		{
			string strRet = "";
			// The absolutely slowest method I can write
			for (ulong uIndex = 1; uIndex < mToFactor; uIndex++)
			{
				double dFloatCalc = (double)mToFactor / (double)uIndex;
				ulong uUlongCalc = mToFactor / uIndex;
				if (dFloatCalc == (double)uUlongCalc)
				{
					if (strRet.Length == 0)
						strRet = uIndex.ToString();
					else
						strRet += ", " + uIndex.ToString();
				}
			}

			return strRet;
		}

		private Thread mExecution;
		public void FactorAsync()
		{
			ThreadStart startThread = new ThreadStart(DoFactoring);
			mExecution = new Thread(startThread);
			mExecution.Start();			
		}

		protected void DoFactoring()
		{
			string strFactor = Factor();
			object[] paramArray = new object[3];
			paramArray[0] = mID;
			paramArray[1] = mToFactor;
			paramArray[2] = strFactor;

			mControllingControl.BeginInvoke(this.FactoringComplete, paramArray);
		}
		
	}
}
