using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Delays
{
	/// <summary>
	/// Summary description for frmWaiting.
	/// </summary>
	public class frmWaiting : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ProgressBar progStatus;
		private System.ComponentModel.IContainer components;

		private dataSetRequest.RequestRow mRow;
		private PollableThreadManager mExecute = null;
		private System.Windows.Forms.Timer tmrFire;

		public frmWaiting(dataSetRequest.RequestRow Row)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			mRow = Row;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.progStatus = new System.Windows.Forms.ProgressBar();
			this.tmrFire = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// progStatus
			// 
			this.progStatus.Dock = System.Windows.Forms.DockStyle.Fill;
			this.progStatus.Name = "progStatus";
			this.progStatus.Size = new System.Drawing.Size(338, 24);
			this.progStatus.TabIndex = 0;
			this.progStatus.Click += new System.EventHandler(this.progStatus_Click);
			// 
			// tmrFire
			// 
			this.tmrFire.Enabled = true;
			this.tmrFire.Interval = 10;
			this.tmrFire.Tick += new System.EventHandler(this.tmrFire_Tick);
			// 
			// frmWaiting
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(338, 24);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.progStatus});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "frmWaiting";
			this.Text = "Waiting for Answer";
			this.Load += new System.EventHandler(this.frmWaiting_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void frmWaiting_Load(object sender, System.EventArgs e)
		{
			mExecute = new PollableThreadManager(mRow.ID, mRow.RequestValue);
			mExecute.BeginExecution();
		}

		private void tmrFire_Tick(object sender, System.EventArgs e)
		{
			AsyncReturn ar = mExecute.WaitForCompletion(100);
			if (ar == AsyncReturn.CompletedSuccessfully)
			{
				tmrFire.Enabled = false;
				mRow.RequestResult = mExecute.Result;
				this.Close();
			}
			else if (ar == AsyncReturn.CompletedUnsuccessfully)
			{
				tmrFire.Enabled = false;
				mRow.RequestResult = mExecute.ExceptionThrown.ToString();
				this.Close();
			}
			else
			{
				if (progStatus.Value >= progStatus.Maximum)
					progStatus.Value = progStatus.Minimum;
				else
					progStatus.Value += 1;
			}

		}

		private void progStatus_Click(object sender, System.EventArgs e)
		{
		
		}

	}
}
