using System;
using System.Runtime.InteropServices;

namespace ThreadDelegate
{
	class Win32Native
	{
		[DllImport("kernel32.dll")]
		internal static extern int GetCurrentThreadId();
	}

	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class MainClass
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			MainClass thisClass = new MainClass();

			int iterations=2;
			if (args.Length > 0)
				iterations = Convert.ToInt32(args[0]);

			thisClass.Execute(iterations);
		}

		private EventSource evtSource = null;

		MainClass()
		{
			evtSource = new EventSource();

			evtSource.Event1 += new EventHandler(this.Event1Handler1);
			evtSource.Event1 += new EventHandler(this.Event1Handler2);
			evtSource.Event1 += new EventHandler(this.Event1Handler3);
			evtSource.Event1 += new EventHandler(this.Event1Handler4);

			evtSource.Event2 += new EventHandler(this.Event2Handler1);
			evtSource.Event2 += new EventHandler(this.Event2Handler2);
			evtSource.Event2 += new EventHandler(this.Event2Handler3);
			evtSource.Event2 += new EventHandler(this.Event2Handler4);
		}

		void Execute(int iterations)
		{
			evtSource.Run(iterations);
		}

		#region Event1 Handlers
		void Event1Handler1(object sender, EventArgs args)
		{
			Console.WriteLine("{0}-Start (ThreadId={1})", System.Reflection.MethodBase.GetCurrentMethod().Name, Win32Native.GetCurrentThreadId());
			HighFrequencyTimer hfTimer = new HighFrequencyTimer();
			hfTimer.Start();
			System.Threading.Thread.Sleep(400);
			hfTimer.Stop();
			Console.WriteLine("{0}-End ({1:F5})", System.Reflection.MethodBase.GetCurrentMethod().Name, hfTimer.ElapsedMilliseconds);
		}
		void Event1Handler2(object sender, EventArgs args)
		{
			Console.WriteLine("{0}-Start (ThreadId={1})", System.Reflection.MethodBase.GetCurrentMethod().Name, Win32Native.GetCurrentThreadId());
			HighFrequencyTimer hfTimer = new HighFrequencyTimer();
			hfTimer.Start();
			System.Threading.Thread.Sleep(400);
			hfTimer.Stop();
			Console.WriteLine("{0}-End ({1:F5})", System.Reflection.MethodBase.GetCurrentMethod().Name, hfTimer.ElapsedMilliseconds);
		}
		void Event1Handler3(object sender, EventArgs args)
		{
			Console.WriteLine("{0}-Start (ThreadId={1})", System.Reflection.MethodBase.GetCurrentMethod().Name, Win32Native.GetCurrentThreadId());
			HighFrequencyTimer hfTimer = new HighFrequencyTimer();
			hfTimer.Start();
			System.Threading.Thread.Sleep(400);
			hfTimer.Stop();
			Console.WriteLine("{0}-End ({1:F5})", System.Reflection.MethodBase.GetCurrentMethod().Name, hfTimer.ElapsedMilliseconds);
		}
		void Event1Handler4(object sender, EventArgs args)
		{
			Console.WriteLine("{0}-Start (ThreadId={1})", System.Reflection.MethodBase.GetCurrentMethod().Name, Win32Native.GetCurrentThreadId());
			HighFrequencyTimer hfTimer = new HighFrequencyTimer();
			hfTimer.Start();
			System.Threading.Thread.Sleep(400);
			hfTimer.Stop();
			Console.WriteLine("{0}-End ({1:F5})", System.Reflection.MethodBase.GetCurrentMethod().Name, hfTimer.ElapsedMilliseconds);
		}
		#endregion


		#region Event2 Handlers
		void Event2Handler1(object sender, EventArgs args)
		{
			Console.WriteLine("\t\t\t{0}-Start (ThreadId={1})", System.Reflection.MethodBase.GetCurrentMethod().Name, Win32Native.GetCurrentThreadId());
			HighFrequencyTimer hfTimer = new HighFrequencyTimer();
			hfTimer.Start();
			System.Threading.Thread.Sleep(400);
			hfTimer.Stop();
			Console.WriteLine("\t\t\t{0}-End ({1:F5})", System.Reflection.MethodBase.GetCurrentMethod().Name, hfTimer.ElapsedMilliseconds);
		}
		void Event2Handler2(object sender, EventArgs args)
		{
			Console.WriteLine("\t\t\t{0}-Start (ThreadId={1})", System.Reflection.MethodBase.GetCurrentMethod().Name, Win32Native.GetCurrentThreadId());
			HighFrequencyTimer hfTimer = new HighFrequencyTimer();
			hfTimer.Start();
			System.Threading.Thread.Sleep(400);
			hfTimer.Stop();
			Console.WriteLine("\t\t\t{0}-End ({1:F5})", System.Reflection.MethodBase.GetCurrentMethod().Name, hfTimer.ElapsedMilliseconds);
		}
		void Event2Handler3(object sender, EventArgs args)
		{
			Console.WriteLine("\t\t\t{0}-Start (ThreadId={1})", System.Reflection.MethodBase.GetCurrentMethod().Name, Win32Native.GetCurrentThreadId());
			HighFrequencyTimer hfTimer = new HighFrequencyTimer();
			hfTimer.Start();
			System.Threading.Thread.Sleep(400);
			hfTimer.Stop();
			Console.WriteLine("\t\t\t{0}-End ({1:F5})", System.Reflection.MethodBase.GetCurrentMethod().Name, hfTimer.ElapsedMilliseconds);
		}
		void Event2Handler4(object sender, EventArgs args)
		{
			Console.WriteLine("\t\t\t{0}-Start (ThreadId={1})", System.Reflection.MethodBase.GetCurrentMethod().Name, Win32Native.GetCurrentThreadId());
			HighFrequencyTimer hfTimer = new HighFrequencyTimer();
			hfTimer.Start();
			System.Threading.Thread.Sleep(400);
			hfTimer.Stop();
			Console.WriteLine("\t\t\t{0}-End ({1:F5})", System.Reflection.MethodBase.GetCurrentMethod().Name, hfTimer.ElapsedMilliseconds);
		}
		#endregion
	}
}
