using System;

namespace Sleeper
{
	/// <summary>
	/// Summary description for Sleeper.
	/// </summary>
	public class Sleeper : TestBed.ITestable
	{
		public static void Sleep(int Milliseconds)
		{
			System.Threading.Thread.Sleep(Milliseconds);
		}

		#region ITestable Interface
		/// <summary>
		/// Will be used to generate random numbers
		/// </summary>
		private Random r = new Random();
		private const string sstrSleepName= "Sleep Time in Milliseconds";

		public System.Collections.SortedList GetTestParameters()
		{
			System.Collections.SortedList list = new System.Collections.SortedList();
			list.Add(sstrSleepName, typeof(int));
			return list;
		}
		public System.Collections.SortedList[] GetTestSet(int Count)
		{
			System.Collections.SortedList[] alist = new System.Collections.SortedList[Count];

			int nFrom, nTo;
			frmFromTo.GetFromTo(out nFrom, out nTo);


			for (int i=0; i < Count; i++)
			{
				alist[i] = new System.Collections.SortedList();
				alist[i].Add(sstrSleepName, r.Next(nFrom, nTo));
			}
			return alist;
		}
		public bool Test(ref System.Collections.SortedList Parameters)
		{
			int val1 = int.Parse(Parameters[sstrSleepName].ToString());
			Sleeper.Sleep(val1);
			Parameters.Add("Result", val1);
			return true;
		}
		#endregion 

	}
}
