// Copyright (c) 2002-2003 Brian Eshelman, EshelTech Consulting.
// All Rights Reserved.  Developed for Dot Net Design Patterns.
// 
// Permission to use, copy, modify, and distribute this 
// software and its documentation for NON-COMMERCIAL purposes
// and without fee is hereby granted provided that this 
// copyright notice appears in all copies. 
//
// THE AUTHOR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT 
// THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR 
// NON-INFRINGEMENT. THE AUTHOR SHALL NOT BE LIABLE FOR ANY 
// DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, 
// MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
// Please send any comments to beshelman@esheltech.com
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;


namespace TestBed
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnAddRequest;
		private TestBed.dataSetRequest dsRequest;
		private DataSet dsRequestValues;
		private CachingTypeLoader Loader = new CachingTypeLoader();

		private System.Windows.Forms.Button btnAddTen;
		private System.Windows.Forms.Button btnAdd60;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btnFactor;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Button btnTestCase;
		private System.Windows.Forms.DataGrid dataGrid2;
		private System.Windows.Forms.Splitter splitter1;
		private System.Data.DataView dvComplete;
		private System.Data.DataView dvInProgress;
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.TextBox txtLoopFor;
		private System.Windows.Forms.TextBox txtKeepAt;
		private System.Windows.Forms.Label label2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dsRequest = new TestBed.dataSetRequest();
			this.btnAddRequest = new System.Windows.Forms.Button();
			this.btnAddTen = new System.Windows.Forms.Button();
			this.btnAdd60 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.btnFactor = new System.Windows.Forms.Button();
			this.label5 = new System.Windows.Forms.Label();
			this.txtLoopFor = new System.Windows.Forms.TextBox();
			this.btnTestCase = new System.Windows.Forms.Button();
			this.dataGrid2 = new System.Windows.Forms.DataGrid();
			this.dvComplete = new System.Data.DataView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.dvInProgress = new System.Data.DataView();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.txtKeepAt = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dsRequest)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dvComplete)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dvInProgress)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dsRequest
			// 
			this.dsRequest.DataSetName = "dataSetRequest";
			this.dsRequest.Locale = new System.Globalization.CultureInfo("en-US");
			this.dsRequest.Namespace = "http://tempuri.org/dataSetRequest.xsd";
			// 
			// btnAddRequest
			// 
			this.btnAddRequest.Location = new System.Drawing.Point(216, 24);
			this.btnAddRequest.Name = "btnAddRequest";
			this.btnAddRequest.Size = new System.Drawing.Size(96, 23);
			this.btnAddRequest.TabIndex = 4;
			this.btnAddRequest.Text = "Add Request";
			this.btnAddRequest.Click += new System.EventHandler(this.btnAddRequest_Click);
			// 
			// btnAddTen
			// 
			this.btnAddTen.Location = new System.Drawing.Point(320, 24);
			this.btnAddTen.Name = "btnAddTen";
			this.btnAddTen.Size = new System.Drawing.Size(88, 23);
			this.btnAddTen.TabIndex = 5;
			this.btnAddTen.Text = "Add 10";
			this.btnAddTen.Click += new System.EventHandler(this.btnAddTen_Click);
			// 
			// btnAdd60
			// 
			this.btnAdd60.Location = new System.Drawing.Point(416, 24);
			this.btnAdd60.Name = "btnAdd60";
			this.btnAdd60.Size = new System.Drawing.Size(104, 23);
			this.btnAdd60.TabIndex = 6;
			this.btnAdd60.Text = "Add 60";
			this.btnAdd60.Click += new System.EventHandler(this.btnAdd60_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(120, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(88, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Notify:";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(120, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(88, 16);
			this.label3.TabIndex = 1;
			this.label3.Text = "Synchronous:";
			// 
			// btnFactor
			// 
			this.btnFactor.Location = new System.Drawing.Point(216, 0);
			this.btnFactor.Name = "btnFactor";
			this.btnFactor.Size = new System.Drawing.Size(96, 23);
			this.btnFactor.TabIndex = 3;
			this.btnFactor.Text = "Execute";
			this.btnFactor.Click += new System.EventHandler(this.btnFactor_Click);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(408, 0);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 16);
			this.label5.TabIndex = 0;
			this.label5.Text = "Loop For:";
			// 
			// txtLoopFor
			// 
			this.txtLoopFor.Location = new System.Drawing.Point(464, 0);
			this.txtLoopFor.Name = "txtLoopFor";
			this.txtLoopFor.Size = new System.Drawing.Size(56, 20);
			this.txtLoopFor.TabIndex = 1;
			this.txtLoopFor.Text = "1000";
			// 
			// btnTestCase
			// 
			this.btnTestCase.Location = new System.Drawing.Point(8, 8);
			this.btnTestCase.Name = "btnTestCase";
			this.btnTestCase.Size = new System.Drawing.Size(96, 23);
			this.btnTestCase.TabIndex = 2;
			this.btnTestCase.Text = "Test Case";
			this.btnTestCase.Click += new System.EventHandler(this.btnTestCase_Click);
			// 
			// dataGrid2
			// 
			this.dataGrid2.DataMember = "";
			this.dataGrid2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.dataGrid2.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid2.Location = new System.Drawing.Point(0, 150);
			this.dataGrid2.Name = "dataGrid2";
			this.dataGrid2.Size = new System.Drawing.Size(640, 328);
			this.dataGrid2.TabIndex = 11;
			// 
			// dvComplete
			// 
			this.dvComplete.RowFilter = "IsNull(RequestTimeSpan, -1) <> -1";
			this.dvComplete.Table = this.dsRequest.Request;
			this.dvComplete.ListChanged += new System.ComponentModel.ListChangedEventHandler(this.dvComplete_ListChanged);
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 147);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(640, 3);
			this.splitter1.TabIndex = 10;
			this.splitter1.TabStop = false;
			this.splitter1.SplitterMoved += new System.Windows.Forms.SplitterEventHandler(this.splitter1_SplitterMoved);
			// 
			// dvInProgress
			// 
			this.dvInProgress.RowFilter = "IsNull(RequestTimeSpan, -1) = -1";
			this.dvInProgress.Table = this.dsRequest.Request;
			this.dvInProgress.ListChanged += new System.ComponentModel.ListChangedEventHandler(this.dvInProgress_ListChanged);
			// 
			// dataGrid1
			// 
			this.dataGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 51);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(640, 96);
			this.dataGrid1.TabIndex = 12;
			// 
			// txtKeepAt
			// 
			this.txtKeepAt.Location = new System.Drawing.Point(368, 0);
			this.txtKeepAt.MaxLength = 2;
			this.txtKeepAt.Name = "txtKeepAt";
			this.txtKeepAt.Size = new System.Drawing.Size(32, 20);
			this.txtKeepAt.TabIndex = 1;
			this.txtKeepAt.Text = "0";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(320, 0);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 16);
			this.label2.TabIndex = 0;
			this.label2.Text = "Keep @:";
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 478);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.dataGrid1,
																		  this.splitter1,
																		  this.btnTestCase,
																		  this.btnFactor,
																		  this.label3,
																		  this.label1,
																		  this.btnAdd60,
																		  this.btnAddTen,
																		  this.btnAddRequest,
																		  this.label5,
																		  this.txtLoopFor,
																		  this.dataGrid2,
																		  this.txtKeepAt,
																		  this.label2});
			this.Name = "frmMain";
			this.Text = "Test Bed";
			this.Load += new System.EventHandler(this.frmMain_Load);
			((System.ComponentModel.ISupportInitialize)(this.dsRequest)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dvComplete)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dvInProgress)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}
		
		private void btnAddRequest_Click(object sender, System.EventArgs e)
		{
			try
			{
				System.Collections.SortedList ParameterList;
				dataSetRequest.RequestRow rr = GetNextRow(out ParameterList);

				NotifyingThreadManager f = new NotifyingThreadManager(ParameterList);
				f.ExecuteAsync(this, 
					new NotifyingThreadManager.CompleteEvent(FactoringComplete), 
					new NotifyingThreadManager.ExceptionEvent(FactoringErrored));
			}
			catch(Exception ex)
			{
				LogException(ex);
				MessageBox.Show("An exception occurred");
			}

		}

		private void btnAddTen_Click(object sender, System.EventArgs e)
		{
			for (int i=0; i<10; i++)
				btnAddRequest_Click(sender, e);
		}

		private void btnAdd60_Click(object sender, System.EventArgs e)
		{
			for (int i=0; i<60; i++)
				btnAddRequest_Click(sender, e);
		}

		private void btnFactor_Click(object sender, System.EventArgs e)
		{
			Cursor curOriginal = Cursor.Current;
			Cursor.Current = Cursors.WaitCursor;
			try
			{
				System.Collections.SortedList ParameterList;
				dataSetRequest.RequestRow rr = GetNextRow(out ParameterList);
					
				TestBed.ITestable iface = GetTestObject(rr);
				iface.Test(ref ParameterList);
				
				CompleteOperation(rr, ParameterList["Result"].ToString(), ParameterList);
			}
			catch(Exception ex)
			{
				LogException(ex);
			}
			finally
			{
				Cursor.Current = curOriginal;
			}
		}

		/// <summary>
		/// This method will receive the successful completion of the operation
		/// </summary>
		/// <param name="ID"></param>
		/// <param name="ToFactor"></param>
		/// <param name="RequestValue"></param>
		protected void FactoringComplete(bool Return, System.Collections.SortedList ParamList)
		{
			Cursor curOriginal = Cursor.Current;
			Cursor.Current = Cursors.WaitCursor;
			try
			{
				dataSetRequest.RequestRow rr = GetRow((int)ParamList["ID"]);
				if (rr != null)
					CompleteOperation(rr, ParamList["Result"].ToString(), ParamList);
			}
			catch(Exception ex)
			{
				LogException(ex);
			}
			finally
			{
				Cursor.Current = curOriginal;
			}
		}

		/// <summary>
		/// This method will receive any exceptions thrown by the operation
		/// </summary>
		/// <param name="ID"></param>
		/// <param name="ToFactor"></param>
		/// <param name="Ex"></param>
		protected void FactoringErrored(System.Collections.SortedList ParamList, Exception Ex)
		{
			Cursor curOriginal = Cursor.Current;
			Cursor.Current = Cursors.WaitCursor;
			try
			{
				dataSetRequest.RequestRow rr = GetRow((int)ParamList["ID"]);

				if (rr != null)
					CompleteOperation(rr, "Exception:  " + Ex.ToString(), ParamList);
			}
			catch(Exception ex)
			{
				LogException(ex);
			}
			finally
			{
				Cursor.Current = curOriginal;
			}
		}

		/// <summary>
		/// Returns a row for the next value to be factored
		/// </summary>
		/// <returns></returns>
		private dataSetRequest.RequestRow GetNextRow(out System.Collections.SortedList ParameterList)
		{
			ParameterList = new System.Collections.SortedList();
			try
			{
				// Get the next Test Case
				DataRow row = GetRequestRow();
				if (row == null)
					return null;

				// Get the next Test Case
				DataRow rowDef = GetDefinitionRow();
				if (rowDef == null)
					return null;

				dataSetRequest.RequestRow rr = dsRequest.Request.NewRequestRow();
				rr.RequestTime = DateTime.Now.TimeOfDay.ToString();
				rr.RequestResultTime = "Processing...";
				dsRequest.Request.Rows.Add(rr);

				foreach (DataColumn col in row.Table.Columns)
				{
					AddValue(rr.ID, col.ColumnName, row[col]);
					ParameterList.Add(col.ColumnName, row[col]);
				}
				ParameterList.Add("ID", rr.ID);
//				ParameterList.Add("Assembly", rowDef["Assembly"]);
//				ParameterList.Add("Class", rowDef["Class"]);
//				AddValue(rr.ID, "Assembly", rowDef["Assembly"]);
//				AddValue(rr.ID, "Class", rowDef["Class"]);

				return rr;
			}
			catch(Exception ex)
			{
				LogException(ex);
				return null;
			}
		}

		private dataSetRequest.RequestValueRow AddValue(int ID, string Name, object Value)
		{
			dataSetRequest.RequestValueRow row = null;
			DataView view = new DataView(dsRequest.RequestValue);
			view.RowFilter = String.Format("RequestID={0} AND Name={1} AND Value={2}", 
				ID, 
				Sqlize(Name), 
				Sqlize(Value.ToString()));
			if (view.Count > 0)
			{
				row = view[0].Row as dataSetRequest.RequestValueRow;
				row.Value = Value.ToString();
				return row;
			}
			
			row = dsRequest.RequestValue.NewRequestValueRow();
			
			row.RequestID = ID;
			row.Name = Name;
			row.Value = Value.ToString();
			
			dsRequest.RequestValue.Rows.Add(row);

			return row;
		}

		/// <summary>
		/// Completes the operation for a row
		/// </summary>
		/// <param name="rr">The row to be completed</param>
		/// <param name="strResult">The result string</param>
		private void CompleteOperation(dataSetRequest.RequestRow rr, string strResult, System.Collections.SortedList Params)
		{
			try
			{
				rr.RequestResult = strResult;
				rr.RequestResultTime = DateTime.Now.TimeOfDay.ToString();
				TimeSpan ts = (DateTime.Parse(rr.RequestResultTime) - DateTime.Parse(rr.RequestTime));
				rr.RequestTimeSpan = (int)ts.TotalSeconds;
				
				foreach (object oKey in Params)
				{
					System.Collections.DictionaryEntry key = (System.Collections.DictionaryEntry)oKey;
					AddValue(rr.ID, key.Key as string, key.Value.ToString());
				}

				SetThreadLevel();
			}
			catch(Exception ex)
			{
				LogException(ex);
			}
		}

		private void SetThreadLevel()
		{
			int nKeepAt = 0;
			int nNeeded = 0;
			int nLooper = 0;
			try
			{
				nKeepAt = int.Parse(txtKeepAt.Text);
				if (nKeepAt > 0)
				{
					nLooper = int.Parse(txtLoopFor.Text);
					nNeeded = nKeepAt - dvInProgress.Count;
					while (nNeeded > 0)
					{
						lock(txtLoopFor)
						{
							if (nLooper > 0)
							{
								btnAddRequest_Click(null, null);
								nLooper--;
								txtLoopFor.Text = nLooper.ToString();
								nNeeded = nKeepAt - dvInProgress.Count;
							}
							else
								nNeeded = 0;
						}
					}

					
				}
			}
			catch
			{
			}
		}
		/// <summary>
		/// Gets the row specified by an ID
		/// </summary>
		/// <param name="ID">The ID of the row to be retrieved</param>
		/// <returns></returns>
		private dataSetRequest.RequestRow GetRow(int ID)
		{
			dataSetRequest.RequestRow rr = null;
			try
			{
				DataView reqView = new DataView(dsRequest.Request);
				reqView.RowFilter = "ID=" + ID.ToString();
				if (reqView.Count > 0)
				{
					rr = reqView[0].Row as dataSetRequest.RequestRow;
				}
				reqView.RowFilter = "";
				return rr;
			}
			catch(Exception ex)
			{
				LogException(ex);
				return null;
			}
		}

		private int nRowIdx = 0;
		private DataTable GetValuesTable()
		{
			return dsRequestValues.Tables["RequestValues"];
		}

		private DataRow GetRequestRow()
		{
			DataTable tblDefinition = GetValuesTable();

			if (tblDefinition == null)
				return null;

			if (tblDefinition.Rows.Count == 0)
				return null;

			if (tblDefinition.Rows.Count <= nRowIdx )
				nRowIdx = 0;

			return tblDefinition.Rows[nRowIdx++];
		}

		private DataRow GetDefinitionRow()
		{
			DataTable tblDefinition = dsRequestValues.Tables["TestDefinition"];
			DataRow row = null;
			if (tblDefinition != null)
			{
				row = tblDefinition.Rows[0];
			}

			return row;
		}

		/// <summary>
		/// Central location for logging exceptions
		/// </summary>
		/// <param name="ex"></param>
		private void LogException(Exception ex)
		{
			try
			{
				System.Diagnostics.EventLog.WriteEntry(
					Application.ProductName, 
					String.Format("An exception was caught:\n{0}", ex.ToString()),
					System.Diagnostics.EventLogEntryType.Error);
			}
			catch
			{

			}
		}

		private void btnTestCase_Click(object sender, System.EventArgs e)
		{
			frmTestCase frm = new frmTestCase();
			frm.dsRequestValues = dsRequestValues;
			frm.Loader = Loader;

			frm.ShowDialog(this);

			dsRequestValues = frm.dsRequestValues;
		}

		private void frmMain_Load(object sender, System.EventArgs e)
		{
			System.Net.ServicePointManager.DefaultConnectionLimit = 100;
			dsRequestValues = new DataSet("RequestValues");
		}


		
		
		private System.Reflection.Assembly LoadedAssembly = null;
		private string strLoadedAssembly = "";
		
		
		private TestBed.ITestable GetTestObject(dataSetRequest.RequestRow rr)
		{
			string strCurrAssembly = rr["Assembly"] as string;
			if (!strCurrAssembly.Equals(strLoadedAssembly))
			{
				LoadedAssembly = System.Reflection.Assembly.LoadFrom(strCurrAssembly);
				strLoadedAssembly = strCurrAssembly;
			}
			System.Type type = LoadedAssembly.GetType(rr["Class"] as string);
			if (type == null)
				return null;

			TestBed.ITestable iface = type.GetConstructor(System.Type.EmptyTypes).Invoke(System.Type.EmptyTypes) as TestBed.ITestable;
			return iface;
		}

		private void dvComplete_ListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
		{
			if (dvComplete.Count == 0)
				dataGrid2.DataSource = null;
			else
				dataGrid2.DataSource = dvComplete;
		
		}
		
		private void dvInProgress_ListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
		{
			if (dvInProgress.Count == 0)
				dataGrid1.DataSource = null;
			else
				dataGrid1.DataSource = dvInProgress;
		
		}

		private void splitter1_SplitterMoved(object sender, System.Windows.Forms.SplitterEventArgs e)
		{
			dataGrid1.Height = splitter1.Top - dataGrid1.Top - 2;
		}



	

		#region For Building SQL Strings
		/// <summary>
		/// Convert a value into the appropriate format to be passed in to a SQL string
		/// </summary>
		/// <param name="raw">Input value</param>
		/// <returns>String properly formatted for SQL appropriate to the type</returns>
		static public string Sqlize(string raw)
		{
			if (raw == null) return "";

			// Convert single quotes into double single quotes
			return String.Format("'{0}'", raw.Replace("'", "''"));
		}
		#endregion For Building SQL Strings

	}
}
