using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Text;
using System.Net.Sockets;
using System.Threading;
using System.Diagnostics;
using RemoteTracer;

namespace RemoteTraceViewer
{
	/// <summary>
	/// This is the Remote Trace Viewer and General Socket Server Test Harness for Paymetric.NET
	/// </summary>
	public class frmSocketServer : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdListen;
		private System.Windows.Forms.Button cmdStop;

		internal static TcpListener oListener = null;
		internal static Socket oSocket = null;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TabControl tabTrace;
		private System.Windows.Forms.TabPage tabActiveTrace;
		private System.Windows.Forms.TabPage tabQueuedTrace;
		private System.Windows.Forms.Button cmdClear;
		
		private System.Threading.Timer oQueuedTraceTimer = null;
		private System.Windows.Forms.CheckBox chkEnabledStreamed;
		private System.Windows.Forms.CheckBox chkEnableQueued;
		private System.Windows.Forms.TabPage tabStatus;
		private System.Threading.Timer oActiveTraceTimer = null;

		private System.Windows.Forms.Button cmdRefresh;
		private System.Windows.Forms.DataGrid ActiveTraceGrid;
		private System.Windows.Forms.Button cmdTest;

		internal static TraceInfo dsActiveTraceData = null;
		internal static TraceInfo dsActiveTraceDataCopy = null;
		internal static TraceInfo dsQueuedTraceData = null;
		private System.Windows.Forms.DataGrid QueuedTraceGrid;
		private System.Windows.Forms.DataGrid StatusGrid;
		internal static TraceInfo dsQueuedTraceDataCopy = null;
		private System.Windows.Forms.CheckBox chkExpandRowHeight;
		internal static bool bDirty = false;

		public frmSocketServer()
		{
			
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			frmSocketServer.dsActiveTraceData = new TraceInfo();
			frmSocketServer.dsActiveTraceDataCopy = new TraceInfo();
			
			frmSocketServer.dsQueuedTraceData = new TraceInfo();
			frmSocketServer.dsQueuedTraceDataCopy = new TraceInfo();

			Application.Idle += new System.EventHandler(this.OnIdle);
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdListen = new System.Windows.Forms.Button();
			this.cmdStop = new System.Windows.Forms.Button();
			this.tabTrace = new System.Windows.Forms.TabControl();
			this.tabActiveTrace = new System.Windows.Forms.TabPage();
			this.ActiveTraceGrid = new System.Windows.Forms.DataGrid();
			this.tabQueuedTrace = new System.Windows.Forms.TabPage();
			this.QueuedTraceGrid = new System.Windows.Forms.DataGrid();
			this.tabStatus = new System.Windows.Forms.TabPage();
			this.StatusGrid = new System.Windows.Forms.DataGrid();
			this.cmdClear = new System.Windows.Forms.Button();
			this.chkEnabledStreamed = new System.Windows.Forms.CheckBox();
			this.chkEnableQueued = new System.Windows.Forms.CheckBox();
			this.cmdRefresh = new System.Windows.Forms.Button();
			this.cmdTest = new System.Windows.Forms.Button();
			this.chkExpandRowHeight = new System.Windows.Forms.CheckBox();
			this.tabTrace.SuspendLayout();
			this.tabActiveTrace.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.ActiveTraceGrid)).BeginInit();
			this.tabQueuedTrace.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.QueuedTraceGrid)).BeginInit();
			this.tabStatus.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.StatusGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// cmdListen
			// 
			this.cmdListen.Location = new System.Drawing.Point(760, 8);
			this.cmdListen.Name = "cmdListen";
			this.cmdListen.Size = new System.Drawing.Size(104, 23);
			this.cmdListen.TabIndex = 0;
			this.cmdListen.Text = "Listen";
			this.cmdListen.Click += new System.EventHandler(this.cmdListen_Click);
			// 
			// cmdStop
			// 
			this.cmdStop.Enabled = false;
			this.cmdStop.Location = new System.Drawing.Point(760, 32);
			this.cmdStop.Name = "cmdStop";
			this.cmdStop.Size = new System.Drawing.Size(104, 23);
			this.cmdStop.TabIndex = 0;
			this.cmdStop.Text = "Stop";
			this.cmdStop.Click += new System.EventHandler(this.cmdStop_Click);
			// 
			// tabTrace
			// 
			this.tabTrace.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.tabActiveTrace,
																				   this.tabQueuedTrace,
																				   this.tabStatus});
			this.tabTrace.Location = new System.Drawing.Point(8, 96);
			this.tabTrace.Name = "tabTrace";
			this.tabTrace.SelectedIndex = 0;
			this.tabTrace.Size = new System.Drawing.Size(856, 448);
			this.tabTrace.TabIndex = 2;
			// 
			// tabActiveTrace
			// 
			this.tabActiveTrace.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.ActiveTraceGrid});
			this.tabActiveTrace.Location = new System.Drawing.Point(4, 22);
			this.tabActiveTrace.Name = "tabActiveTrace";
			this.tabActiveTrace.Size = new System.Drawing.Size(848, 422);
			this.tabActiveTrace.TabIndex = 0;
			this.tabActiveTrace.Text = "Active Trace";
			// 
			// ActiveTraceGrid
			// 
			this.ActiveTraceGrid.AlternatingBackColor = System.Drawing.Color.Lavender;
			this.ActiveTraceGrid.BackColor = System.Drawing.Color.WhiteSmoke;
			this.ActiveTraceGrid.BackgroundColor = System.Drawing.Color.LightGray;
			this.ActiveTraceGrid.CaptionBackColor = System.Drawing.Color.LightSteelBlue;
			this.ActiveTraceGrid.CaptionForeColor = System.Drawing.Color.MidnightBlue;
			this.ActiveTraceGrid.CaptionText = "Active Trace Messages";
			this.ActiveTraceGrid.DataMember = "";
			this.ActiveTraceGrid.FlatMode = true;
			this.ActiveTraceGrid.Font = new System.Drawing.Font("Tahoma", 8F);
			this.ActiveTraceGrid.ForeColor = System.Drawing.Color.MidnightBlue;
			this.ActiveTraceGrid.GridLineColor = System.Drawing.Color.Gainsboro;
			this.ActiveTraceGrid.GridLineStyle = System.Windows.Forms.DataGridLineStyle.None;
			this.ActiveTraceGrid.HeaderBackColor = System.Drawing.Color.MidnightBlue;
			this.ActiveTraceGrid.HeaderFont = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.ActiveTraceGrid.HeaderForeColor = System.Drawing.Color.WhiteSmoke;
			this.ActiveTraceGrid.LinkColor = System.Drawing.Color.Teal;
			this.ActiveTraceGrid.Location = new System.Drawing.Point(8, 8);
			this.ActiveTraceGrid.Name = "ActiveTraceGrid";
			this.ActiveTraceGrid.ParentRowsBackColor = System.Drawing.Color.Gainsboro;
			this.ActiveTraceGrid.ParentRowsForeColor = System.Drawing.Color.MidnightBlue;
			this.ActiveTraceGrid.PreferredColumnWidth = 50;
			this.ActiveTraceGrid.PreferredRowHeight = 80;
			this.ActiveTraceGrid.ReadOnly = true;
			this.ActiveTraceGrid.SelectionBackColor = System.Drawing.Color.CadetBlue;
			this.ActiveTraceGrid.SelectionForeColor = System.Drawing.Color.WhiteSmoke;
			this.ActiveTraceGrid.Size = new System.Drawing.Size(832, 408);
			this.ActiveTraceGrid.TabIndex = 0;
			// 
			// tabQueuedTrace
			// 
			this.tabQueuedTrace.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.QueuedTraceGrid});
			this.tabQueuedTrace.Location = new System.Drawing.Point(4, 22);
			this.tabQueuedTrace.Name = "tabQueuedTrace";
			this.tabQueuedTrace.Size = new System.Drawing.Size(848, 422);
			this.tabQueuedTrace.TabIndex = 1;
			this.tabQueuedTrace.Text = "Queued Trace";
			// 
			// QueuedTraceGrid
			// 
			this.QueuedTraceGrid.AlternatingBackColor = System.Drawing.Color.Lavender;
			this.QueuedTraceGrid.BackColor = System.Drawing.Color.WhiteSmoke;
			this.QueuedTraceGrid.BackgroundColor = System.Drawing.Color.LightGray;
			this.QueuedTraceGrid.CaptionBackColor = System.Drawing.Color.LightSteelBlue;
			this.QueuedTraceGrid.CaptionForeColor = System.Drawing.Color.MidnightBlue;
			this.QueuedTraceGrid.CaptionText = "Queued Trace Messages";
			this.QueuedTraceGrid.DataMember = "";
			this.QueuedTraceGrid.FlatMode = true;
			this.QueuedTraceGrid.Font = new System.Drawing.Font("Tahoma", 8F);
			this.QueuedTraceGrid.ForeColor = System.Drawing.Color.MidnightBlue;
			this.QueuedTraceGrid.GridLineColor = System.Drawing.Color.Gainsboro;
			this.QueuedTraceGrid.GridLineStyle = System.Windows.Forms.DataGridLineStyle.None;
			this.QueuedTraceGrid.HeaderBackColor = System.Drawing.Color.MidnightBlue;
			this.QueuedTraceGrid.HeaderFont = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.QueuedTraceGrid.HeaderForeColor = System.Drawing.Color.WhiteSmoke;
			this.QueuedTraceGrid.LinkColor = System.Drawing.Color.Teal;
			this.QueuedTraceGrid.Location = new System.Drawing.Point(8, 7);
			this.QueuedTraceGrid.Name = "QueuedTraceGrid";
			this.QueuedTraceGrid.ParentRowsBackColor = System.Drawing.Color.Gainsboro;
			this.QueuedTraceGrid.ParentRowsForeColor = System.Drawing.Color.MidnightBlue;
			this.QueuedTraceGrid.PreferredColumnWidth = 50;
			this.QueuedTraceGrid.ReadOnly = true;
			this.QueuedTraceGrid.SelectionBackColor = System.Drawing.Color.CadetBlue;
			this.QueuedTraceGrid.SelectionForeColor = System.Drawing.Color.WhiteSmoke;
			this.QueuedTraceGrid.Size = new System.Drawing.Size(832, 409);
			this.QueuedTraceGrid.TabIndex = 1;
			// 
			// tabStatus
			// 
			this.tabStatus.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.StatusGrid});
			this.tabStatus.Location = new System.Drawing.Point(4, 22);
			this.tabStatus.Name = "tabStatus";
			this.tabStatus.Size = new System.Drawing.Size(848, 422);
			this.tabStatus.TabIndex = 2;
			this.tabStatus.Text = "Status";
			// 
			// StatusGrid
			// 
			this.StatusGrid.AlternatingBackColor = System.Drawing.Color.Lavender;
			this.StatusGrid.BackColor = System.Drawing.Color.WhiteSmoke;
			this.StatusGrid.BackgroundColor = System.Drawing.Color.LightGray;
			this.StatusGrid.CaptionBackColor = System.Drawing.Color.LightSteelBlue;
			this.StatusGrid.CaptionForeColor = System.Drawing.Color.MidnightBlue;
			this.StatusGrid.CaptionText = "Tracing Status";
			this.StatusGrid.DataMember = "";
			this.StatusGrid.FlatMode = true;
			this.StatusGrid.Font = new System.Drawing.Font("Tahoma", 8F);
			this.StatusGrid.ForeColor = System.Drawing.Color.MidnightBlue;
			this.StatusGrid.GridLineColor = System.Drawing.Color.Gainsboro;
			this.StatusGrid.GridLineStyle = System.Windows.Forms.DataGridLineStyle.None;
			this.StatusGrid.HeaderBackColor = System.Drawing.Color.MidnightBlue;
			this.StatusGrid.HeaderFont = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.StatusGrid.HeaderForeColor = System.Drawing.Color.WhiteSmoke;
			this.StatusGrid.LinkColor = System.Drawing.Color.Teal;
			this.StatusGrid.Location = new System.Drawing.Point(8, 7);
			this.StatusGrid.Name = "StatusGrid";
			this.StatusGrid.ParentRowsBackColor = System.Drawing.Color.Gainsboro;
			this.StatusGrid.ParentRowsForeColor = System.Drawing.Color.MidnightBlue;
			this.StatusGrid.PreferredColumnWidth = 50;
			this.StatusGrid.ReadOnly = true;
			this.StatusGrid.SelectionBackColor = System.Drawing.Color.CadetBlue;
			this.StatusGrid.SelectionForeColor = System.Drawing.Color.WhiteSmoke;
			this.StatusGrid.Size = new System.Drawing.Size(832, 409);
			this.StatusGrid.TabIndex = 2;
			// 
			// cmdClear
			// 
			this.cmdClear.Location = new System.Drawing.Point(760, 56);
			this.cmdClear.Name = "cmdClear";
			this.cmdClear.Size = new System.Drawing.Size(104, 23);
			this.cmdClear.TabIndex = 4;
			this.cmdClear.Text = "Clear";
			this.cmdClear.Click += new System.EventHandler(this.cmdClear_Click);
			// 
			// chkEnabledStreamed
			// 
			this.chkEnabledStreamed.Location = new System.Drawing.Point(16, 56);
			this.chkEnabledStreamed.Name = "chkEnabledStreamed";
			this.chkEnabledStreamed.Size = new System.Drawing.Size(152, 24);
			this.chkEnabledStreamed.TabIndex = 5;
			this.chkEnabledStreamed.Text = "Enable Streamed Tracing";
			// 
			// chkEnableQueued
			// 
			this.chkEnableQueued.Checked = true;
			this.chkEnableQueued.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkEnableQueued.Location = new System.Drawing.Point(184, 56);
			this.chkEnableQueued.Name = "chkEnableQueued";
			this.chkEnableQueued.Size = new System.Drawing.Size(152, 24);
			this.chkEnableQueued.TabIndex = 6;
			this.chkEnableQueued.Text = "Enable Queued Tracing";
			// 
			// cmdRefresh
			// 
			this.cmdRefresh.Enabled = false;
			this.cmdRefresh.Location = new System.Drawing.Point(760, 80);
			this.cmdRefresh.Name = "cmdRefresh";
			this.cmdRefresh.Size = new System.Drawing.Size(104, 23);
			this.cmdRefresh.TabIndex = 7;
			this.cmdRefresh.Text = "Refresh";
			this.cmdRefresh.Click += new System.EventHandler(this.cmdRefresh_Click);
			// 
			// cmdTest
			// 
			this.cmdTest.Location = new System.Drawing.Point(648, 56);
			this.cmdTest.Name = "cmdTest";
			this.cmdTest.Size = new System.Drawing.Size(104, 23);
			this.cmdTest.TabIndex = 8;
			this.cmdTest.Text = "Test";
			this.cmdTest.Click += new System.EventHandler(this.cmdTest_Click);
			// 
			// chkExpandRowHeight
			// 
			this.chkExpandRowHeight.Checked = true;
			this.chkExpandRowHeight.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkExpandRowHeight.Location = new System.Drawing.Point(344, 56);
			this.chkExpandRowHeight.Name = "chkExpandRowHeight";
			this.chkExpandRowHeight.Size = new System.Drawing.Size(144, 24);
			this.chkExpandRowHeight.TabIndex = 9;
			this.chkExpandRowHeight.Text = "Expand Row Height";
			this.chkExpandRowHeight.CheckedChanged += new System.EventHandler(this.chkExpandRowHeight_CheckedChanged);
			// 
			// frmSocketServer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(872, 551);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chkExpandRowHeight,
																		  this.cmdTest,
																		  this.cmdRefresh,
																		  this.chkEnableQueued,
																		  this.chkEnabledStreamed,
																		  this.cmdClear,
																		  this.tabTrace,
																		  this.cmdStop,
																		  this.cmdListen});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "frmSocketServer";
			this.Text = "Remote Trace Viewer";
			this.tabTrace.ResumeLayout(false);
			this.tabActiveTrace.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.ActiveTraceGrid)).EndInit();
			this.tabQueuedTrace.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.QueuedTraceGrid)).EndInit();
			this.tabStatus.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.StatusGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmSocketServer());
		}

		private void cmdListen_Click(object sender, System.EventArgs e)
		{
			try 
			{
				cmdListen.Enabled = false;
				cmdStop.Enabled = true;
				cmdRefresh.Enabled = true;

				if (chkEnableQueued.Checked)
					oQueuedTraceTimer = new System.Threading.Timer(new TimerCallback(ProcessQueuedTrace), null, 0, 40000);
				
				if (chkEnabledStreamed.Checked)
					oActiveTraceTimer = new System.Threading.Timer(new TimerCallback(ProcessActiveTrace), null, 0, System.Threading.Timeout.Infinite);
								
			}
			catch (Exception err) 
			{
				EventLog.WriteEntry("SocketServer", "Trace Error: " + err.StackTrace);
			}    

		}

		private void cmdStop_Click(object sender, System.EventArgs e)
		{
			StopListening();
		}

		/// <summary>
		/// Delegated Event Method for Timer to process Queued trace messages
		/// </summary>
		/// <param name="state"></param>
		static void ProcessQueuedTrace(Object state) 
		{
			EventLog oElog = new EventLog("Application", Dns.GetHostName(), "TraceViewMain");
			Messenger oMessenger = new Messenger();
			BusinessMessage oMessageIn = oMessenger.MessageInfo;
			BusinessMessage oMessageOut;
			
			try
			{
				// must set the message type we are looking for, this looks in the correct queue
				oMessageIn.MessageType = "trace";
						
				while (true)
				{
					// grab the message from the queue
					WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Listening for trace messages on the trace queue...");
					oMessageOut = oMessenger.Receive(oMessageIn, 10); // set timeout to 5 seconds, when time elapses exception will be thrown and caught gracefully
					
					// to keep to message text from scolling off of the page this a good cutoff for the source lenght
					string sSource = oMessageOut.UserId;
					string sDate = DateTime.Now.ToShortDateString();
					string sTime = DateTime.Now.ToShortTimeString();
					string sMessage = oMessageOut.MessageText;	
					//sMessage = sMessage.Replace('\n', '-');
											
					frmSocketServer.dsQueuedTraceData.TraceMessage.AddTraceMessageRow(sDate, sTime, sSource, sMessage);				
					frmSocketServer.dsQueuedTraceData.TraceMessage.AcceptChanges();
					frmSocketServer.bDirty = true;

				} // keep looping until there are no message left to process, exception should be thrown when the queue is empty
				
			}
			catch (Exception e)
			{
				// exception was probably thrown when no message could be found/timeout expired
				if (e.Message.StartsWith("Timeout"))
				{
					WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Timeout expired listening for messages on trace queue.");
				}
				else
				{
					oElog.WriteEntry("SocketServer - Error Occured During Message Receipt and Processing: " + e.ToString());
				}
			}
		}

		/// <summary>
		/// Called to stop the tcp listener, close any open socket, and shutdown the timers
		/// </summary>
		private void StopListening()
		{
			cmdListen.Enabled = true;
			cmdStop.Enabled = false;
			cmdRefresh.Enabled = false;

			if (oSocket != null)
			{
				WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Closing Socket ..." + oSocket.LocalEndPoint.ToString());
				oSocket.Close();
				oSocket = null;
			}
			if (oListener != null)
			{
				WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Stopping Listener ..." + oListener.LocalEndpoint.ToString());
				oListener.Stop();
				oListener = null;
			}

			if (oQueuedTraceTimer != null)
				oQueuedTraceTimer.Dispose();
			if (oActiveTraceTimer != null)
				oActiveTraceTimer.Dispose();
		}

		/// <summary>
		/// Delegated event method to process socket streamed trace messages
		/// </summary>
		/// <param name="state"></param>
		static void ProcessActiveTrace(Object state) 
		{
			EventLog oElog = new EventLog("Application", Dns.GetHostName(), "TraceViewMain");
			string sSource = null;
			int nDelimPos = 0;
			
			try
			{
				if (oListener == null)
				{
					// an updated means of retrieving the local IP address should be added here - compliant for .NET framework 1.0 only
					long lIP = Dns.GetHostByName(Dns.GetHostName()).AddressList[0].Address;
					IPAddress ipAd = new IPAddress(lIP); // use local m/c IP address, and 
					
					oListener = new TcpListener(ipAd, 8001);

					oListener.Start();
			    
					WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "The server is running at port 8001...");    
					WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "The local End point is  :" + oListener.LocalEndpoint);
					
					while (true)
					{
						WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Waiting for a connection on : " + oListener.LocalEndpoint);
			    
						oSocket = oListener.AcceptSocket();
						WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Connection accepted from " + oSocket.RemoteEndPoint);
			    
						// prepare and receive byte array
						byte[] baBytes = new byte[1000];
						int k = oSocket.Receive(baBytes);
						WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Received Message...");

						// lets do it the easy way
						string sReceivedBuffer = Encoding.ASCII.GetString(baBytes, 0, baBytes.Length);
						WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), sReceivedBuffer);
						
						ASCIIEncoding asen = new ASCIIEncoding();
						oSocket.Send(asen.GetBytes("trace received"));
						WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Sent Acknowledgement to " + oSocket.RemoteEndPoint);
							
						nDelimPos = sReceivedBuffer.IndexOf(":");
						sSource = sReceivedBuffer.Substring(0, nDelimPos);
						string sDate = DateTime.Now.ToShortDateString();
						string sTime = DateTime.Now.ToShortTimeString();
						string sMessage = sReceivedBuffer.Substring(nDelimPos + 1, sReceivedBuffer.Length - (nDelimPos + 1));

						//sMessage = sMessage.Replace('\n', '-');
						
						frmSocketServer.dsActiveTraceData.TraceMessage.AddTraceMessageRow(sDate, sTime, sSource, sMessage);				
						frmSocketServer.dsActiveTraceData.TraceMessage.AcceptChanges();
						frmSocketServer.bDirty = true;
					}
				}
			}
			catch (Exception e)
			{
				// exception was probably thrown when listening loop was stopped by user
				// so check for this exception, and write status, only bother user during a real error.
				if (e.Message.StartsWith("A blocking operation"))
				{
					WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Socket listener was canceled by the system.");
				}
				else
				{
					System.Windows.Forms.MessageBox.Show("Error During Active Trace Listening: " + e.Message);
					oElog.WriteEntry("SocketServer - Error Occured During Message Streaming and Processing: " + e.ToString());
				}
			}
			finally
			{
				if (oSocket != null)
				{
					WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Closing Socket ..." + oSocket.LocalEndPoint.ToString());
					oSocket.Close();
					oSocket = null;
				}
				if (oListener != null)
				{
					WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Stopping Listener ..." + oListener.LocalEndpoint.ToString());
					oListener.Stop();
					oListener = null;
				}
			}
		}

		/// <summary>
		/// This clears both trace outputs
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void cmdClear_Click(object sender, System.EventArgs e)
		{
			frmSocketServer.dsActiveTraceDataCopy.Clear();
			frmSocketServer.dsQueuedTraceDataCopy.Clear();
		}

		/// <summary>
		/// Adds a new message to the status tab
		/// </summary>
		/// <param name="sDate"></param>
		/// <param name="sTime"></param>
		/// <param name="sMessage"></param>
		internal static void WriteStatus(string sDate, string sTime, string sMessage)
		{
			frmSocketServer.dsActiveTraceData.StatusMessage.AddStatusMessageRow(sDate, sTime, sMessage);				
			frmSocketServer.dsActiveTraceData.StatusMessage.AcceptChanges();
		}

		private void cmdRefresh_Click(object sender, System.EventArgs e)
		{
			RefreshGrids();
		}

		/// <summary>
		/// Refreshes the grid and column formats, also rebinds copy of dataset to each grid for update data
		/// </summary>
		private void RefreshGrids()
		{
			if (chkExpandRowHeight.Checked)
			{
				ActiveTraceGrid.PreferredRowHeight = 144;
				QueuedTraceGrid.PreferredRowHeight = 144;
			}
			else
			{
				ActiveTraceGrid.PreferredRowHeight = 48;
				QueuedTraceGrid.PreferredRowHeight = 48;
			}

			// copy active (streamed) grid's data and bind to grid
			ActiveTraceGrid.TableStyles.Clear();
			frmSocketServer.dsActiveTraceDataCopy = (TraceInfo) frmSocketServer.dsActiveTraceData.Copy();
			ActiveTraceGrid.DataSource = frmSocketServer.dsActiveTraceDataCopy.Tables[frmSocketServer.dsActiveTraceData.Tables[0].TableName];
			
			// copy queued (streamed) grid's data and bind to grid
			QueuedTraceGrid.TableStyles.Clear();
			frmSocketServer.dsQueuedTraceDataCopy = (TraceInfo) frmSocketServer.dsQueuedTraceData.Copy();
			QueuedTraceGrid.DataSource = frmSocketServer.dsQueuedTraceDataCopy.Tables[frmSocketServer.dsQueuedTraceData.Tables[0].TableName];
			
			// simply bind copy of status messages
			StatusGrid.TableStyles.Clear();
			StatusGrid.DataSource = frmSocketServer.dsActiveTraceDataCopy.Tables[frmSocketServer.dsActiveTraceData.Tables[1].TableName];
			
			// refresh all grids
			ActiveTraceGrid.Refresh();
			QueuedTraceGrid.Refresh();
			StatusGrid.Refresh();
					
			// this is absolutely required if you want to begin using the grid styles in code
			// format the active trace grid
			if (frmSocketServer.dsActiveTraceDataCopy.Tables.Count > 0)
			{
				if (ActiveTraceGrid.TableStyles.Count == 0)
				{
					ActiveTraceGrid.TableStyles.Add(new DataGridTableStyle(true));
					ActiveTraceGrid.TableStyles[0].MappingName = frmSocketServer.dsActiveTraceData.Tables[0].TableName;
					FormatMessageGrid(ActiveTraceGrid, true);
				}
						
			}
	
			// format the queued trace grid
			if (frmSocketServer.dsQueuedTraceDataCopy.Tables.Count > 0)
			{
				if (QueuedTraceGrid.TableStyles.Count == 0)
				{
					QueuedTraceGrid.TableStyles.Add(new DataGridTableStyle(true));
					QueuedTraceGrid.TableStyles[0].MappingName = frmSocketServer.dsQueuedTraceDataCopy.Tables[0].TableName;
					FormatMessageGrid(QueuedTraceGrid, true);
				}
			}
	
			// format the status grid -- uses the ActiveTrace dataset's status table -- could have used the queued trace but 
			// we are writing to the active trace dataset (by choice)
			if (frmSocketServer.dsActiveTraceDataCopy.Tables.Count > 1) // more than one means a status table with records should be there to display
			{
				if (StatusGrid.TableStyles.Count == 0)
				{
					StatusGrid.TableStyles.Add(new DataGridTableStyle(true));
					StatusGrid.TableStyles[0].MappingName = frmSocketServer.dsActiveTraceDataCopy.Tables[1].TableName;
					FormatMessageGrid(StatusGrid, false);
				}
			}
			frmSocketServer.bDirty = false;

		}

		/// <summary>
		/// Formats the columns in the grids
		/// </summary>
		/// <param name="oGrid"></param>
		/// <param name="bIncludeSourceCol"></param>
		private void FormatMessageGrid(System.Windows.Forms.DataGrid oGrid, bool bIncludeSourceCol)
		{
			// if column styles haven't been set, create them..
			if (oGrid.TableStyles[0].GridColumnStyles.Count == 0)
			{
				oGrid.TableStyles[0].GridColumnStyles.Add(new DataGridTextBoxColumn());
				oGrid.TableStyles[0].GridColumnStyles.Add(new DataGridTextBoxColumn());
				oGrid.TableStyles[0].GridColumnStyles.Add(new DataGridTextBoxColumn());
				if (bIncludeSourceCol)
					oGrid.TableStyles[0].GridColumnStyles.Add(new DataGridTextBoxColumn());
			}
						
			oGrid.TableStyles[0].GridColumnStyles[0].Width = 90;
			// you must set each columnstyle's mappingname so that other properties can be set since this is bound
			oGrid.TableStyles[0].GridColumnStyles[0].MappingName = "Date";
			oGrid.TableStyles[0].GridColumnStyles[0].HeaderText = "Date";
			
			oGrid.TableStyles[0].GridColumnStyles[1].Width = 90;
			// you must set each columnstyle's mappingname so that other properties can be set since this is bound
			oGrid.TableStyles[0].GridColumnStyles[1].MappingName = "Time";
			oGrid.TableStyles[0].GridColumnStyles[1].HeaderText = "Time";

			if (bIncludeSourceCol)
			{
				oGrid.TableStyles[0].GridColumnStyles[2].Width = 150;
				// you must set each columnstyle's mappingname so that other properties can be set since this is bound
				oGrid.TableStyles[0].GridColumnStyles[2].MappingName = "Source";
				oGrid.TableStyles[0].GridColumnStyles[2].HeaderText = "Source of Trace";

				oGrid.TableStyles[0].GridColumnStyles[3].Width = 475;
				// you must set each columnstyle's mappingname so that other properties can be set since this is bound
				oGrid.TableStyles[0].GridColumnStyles[3].MappingName = "Message";
				oGrid.TableStyles[0].GridColumnStyles[3].HeaderText = "Trace Message";
				
				DataGridTextBoxColumn oTextCol = (DataGridTextBoxColumn)oGrid.TableStyles[0].GridColumnStyles[3];
				
				oTextCol.TextBox.AcceptsReturn = true;
				oTextCol.TextBox.Multiline = true;
				oTextCol.TextBox.WordWrap = true;
				oTextCol.TextBox.ScrollBars = ScrollBars.Vertical;
				oTextCol.TextBox.AcceptsTab = true;
				oTextCol.TextBox.ReadOnly = true; 
			
			}
			else
			{
				oGrid.TableStyles[0].GridColumnStyles[2].Width = 2000;
				// you must set each columnstyle's mappingname so that other properties can be set since this is bound
				oGrid.TableStyles[0].GridColumnStyles[2].MappingName = "Message";
				oGrid.TableStyles[0].GridColumnStyles[2].HeaderText = "Status Message";
			}
		}

		private void cmdTest_Click(object sender, System.EventArgs e)
		{
			try
			{
				throw new BaseException(this, 0, "This is a test 1,2,3,4,5", new Exception("this is the chained message", null), true);

			}
			catch (Exception ex)
			{
				Console.Out.WriteLine(ex.Message);
				//do nothing
			}


		}

		private void OnIdle(object sender, System.EventArgs e)
		{
			try
			{
				if (frmSocketServer.bDirty)
					RefreshGrids();
			}
			catch (Exception ex)
			{
				Console.Out.WriteLine(ex.Message);
				//do nothing
			}
		}

		private void chkExpandRowHeight_CheckedChanged(object sender, System.EventArgs e)
		{
			RefreshGrids();
		}
	}

	internal class SocketWorker 
	{
		/// <summary>
		/// Delegate thread worker method to process socket streamed trace messages
		/// </summary>
		/// <param name="state"></param>
		void ProcessActiveTrace() 
		{
			EventLog oElog = new EventLog("Application", Dns.GetHostName(), "TraceViewMain");
			string sSource = null;
			int nDelimPos = 0;
			Socket oSocket = frmSocketServer.oSocket;
			TcpListener oListener = frmSocketServer.oListener;
			
			try
			{
				if (oListener == null)
				{
					long lIP = Dns.GetHostByName(Dns.GetHostName()).AddressList[0].Address;
					IPAddress ipAd = new IPAddress(lIP); // use local m/c IP address, and 
					
					oListener = new TcpListener(ipAd, 8001);

					oListener.Start();
			    
					frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "The server is running at port 8001...");    
					frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "The local End point is  :" + oListener.LocalEndpoint);
					
					while (true)
					{
						frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Waiting for a connection on : " + oListener.LocalEndpoint);
			    
						oSocket = oListener.AcceptSocket();
						frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Connection accepted from " + oSocket.RemoteEndPoint);
			    
						// prepare and receive byte array
						byte[] baBytes = new byte[1000];
						int k = oSocket.Receive(baBytes);
						frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Received Message...");

						// lets do it the easy way
						string sReceivedBuffer = Encoding.ASCII.GetString(baBytes, 0, baBytes.Length);
						frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), sReceivedBuffer);
						
						ASCIIEncoding asen = new ASCIIEncoding();
						oSocket.Send(asen.GetBytes("trace received"));
						frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Sent Acknowledgement to " + oSocket.RemoteEndPoint);
							
						nDelimPos = sReceivedBuffer.IndexOf(":");
						sSource = sReceivedBuffer.Substring(0, nDelimPos);
						string sDate = DateTime.Now.ToShortDateString();
						string sTime = DateTime.Now.ToShortTimeString();
						string sMessage = sReceivedBuffer.Substring(nDelimPos + 1, sReceivedBuffer.Length - (nDelimPos + 1));

						sMessage = sMessage.Replace('\n', '-');
						
						frmSocketServer.dsActiveTraceData.TraceMessage.AddTraceMessageRow(sDate, sTime, sSource, sMessage);				
						frmSocketServer.dsActiveTraceData.TraceMessage.AcceptChanges();
					}
				}
			}
			catch (Exception e)
			{
				// exception was probably thrown when listening loop was stopped by user
				// so check for this exception, and write status, only bother user during a real error.
				if (e.Message.StartsWith("A blocking operation"))
				{
					frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Socket listener was canceled by the system.");
				}
				else
				{
					System.Windows.Forms.MessageBox.Show("Error During Active Trace Listening: " + e.Message);
					oElog.WriteEntry("SocketServer - Error Occured During Message Streaming and Processing: " + e.ToString());
				}
			}
			finally
			{
				if (oSocket != null)
				{
					frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Closing Socket ..." + oSocket.LocalEndPoint.ToString());
					oSocket.Close();
					oSocket = null;
				}
				if (oListener != null)
				{
					frmSocketServer.WriteStatus(DateTime.Now.ToShortDateString(), DateTime.Now.ToShortTimeString(), "Stopping Listener ..." + oListener.LocalEndpoint.ToString());
					oListener.Stop();
					oListener = null;
				}
			}
		}


	}

}
