using System;
using System.Diagnostics;
using System.Resources;
using System.Reflection;
using System.Configuration;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Collections;
using DotNetPatterns.Common;


namespace DataTierPatterns.Data
{
	/// <summary>
	/// Summary description for DTPConfig.
	/// </summary>
	public class DTPConfig
	{
		protected DTPConfig()
		{
			SQLText = new ResourceManager(DTPConstants.SQL_TEXT_RESOURCE_NAME, Assembly.GetExecutingAssembly());
			CommonText = new ResourceManager(DTPConstants.COMMON_TEXT_RESOURCE_NAME, Assembly.GetExecutingAssembly());
		}

		#region Properties

		public ResourceManager SQLText
		{
			get {	return m_oSQLTextResource;		}
			set {	m_oSQLTextResource = value;	}
		}

		

		public ResourceManager CommonText
		{
			get {	return m_oCommonTextResource;	}
			set {	m_oCommonTextResource = value;	}
		}
				

		#endregion

		#region Member Functions

		public static DTPConfig GetConfig()
		{
			if (m_oConfig == null)
				m_oConfig = new DTPConfig();

			return m_oConfig;
		}
			
		

		public static string GetSQLText(int iCode)
		{
			return DTPConfig.GetConfig().SQLText.GetString(Convert.ToString(iCode));
		}


		public static string GetCommonText(int iCode)
		{
			return DTPConfig.GetConfig().CommonText.GetString(Convert.ToString(iCode));
		}

		#endregion

		#region Member Variables

		private ResourceManager m_oSQLTextResource;
		private ResourceManager m_oCommonTextResource;
		
		private static DTPConfig m_oConfig;

		#endregion
	}
}