using System;

namespace DataTierPatterns.Data
{
	/// <summary>
	/// Generic types and constants for DataTierPatterns services
	/// </summary>
	public class DTPConstants
	{
		public DTPConstants()
		{

		}

		public enum DBTYPE
		{
			UNKNOWN,
			SQL,
			ORACLE
		}

		public enum SCHEMA_TYPE
		{
			UNKNOWN,
			PRODUCT,
			IDENTITY
		}


		public const int DB_ERROR = -1;
		public const int MAX_DB_ATTEMPTS = 5;
		public const string DEFAULT_TABLENAME = "Table";
		public const string DEFAULT_XML_COLUMN_NAME = "XML_DATA";
		public const string DEFAULT_VERSION_COLUMN_NAME = "VERSION";
		public const string DEFAULT_SCHEMA_ID_COLUMN_NAME = "SCHEMA_ID";
		public const string DEFAULT_TRANS_ID_NAME = "TRANS_ID";

		public const string DEFAULT_DBSERVER = "(local)";
		public const string DEFAULT_DBCATALOG = "PatternsDotNet";
		public const string DEFAULT_DBUSERNAME = "sa";
		public const string DEFAULT_DBPASSWORD = "";
		public const string DEFAULT_DBAPPLICATIONAME = "DataTierPatterns";

		public const bool DEFAULT_DBNTAUTH = true;		
		public const int DEFAULT_DBTIMEOUT = 60;

		public const string DB_TYPE_TEXT = "DBType";
		public const string DB_APPNAME_TEXT = "ApplicationName";
		public const string DB_SERVER_TEXT = "DBServer";
		public const string DB_CATALOG_TEXT = "DBCatalog";
		public const string DB_USERNAME_TEXT = "DBUserName";
		public const string DB_PASSWORD_TEXT = "DBPassword";
		public const string DB_NTAUTH_TEXT = "DBNTAuth";
		public const string DB_TIMEOUT_TEXT = "DBTimeout";

		public const string LOOKUP_DATATABLENAME = "LOOKUP";
		public const string LOOKUP_DATACOLUMN_TABLE = "TABLE";
		public const string LOOKUP_DATACOLUMN_COLUMN = "COLUMN";

		public const string SQL_TEXT_RESOURCE_NAME = "DataTierPatterns.Data.SQLServerText";
		public const string COMMON_TEXT_RESOURCE_NAME = "DataTierPatterns.Data.PolyModelDataCommonText";

		public const int DEFAULT_COUNTER_VALUE = 1;

	}
}
