// TestServer.h : Defines the ATL Server request handler class
//
#pragma once

namespace TestServerService
{
// all struct, enum, and typedefs for your webservice should go inside the namespace

// ITestServerService - web service interface declaration
//
[
	uuid("3832CE7F-7063-4817-8B5F-2F89EF4EBE6B"), 
	object
]
__interface ITestServerService
{
	// HelloWorld is a sample ATL Server web service method.  It shows how to
	// declare a web service method and its in-parameters and out-parameters
	[id(1)] HRESULT HelloWorld([in] BSTR bstrInput, [out, retval] BSTR *bstrOutput);
	// TODO: Add additional web service methods here
};


// TestServerService - web service implementation
//
[
	request_handler(name="Default", sdl="GenTestServerWSDL"),
	soap_handler(
		name="TestServerService", 
		namespace="urn:TestServerService",
		protocol="soap"
	)
]
class CTestServerService :
	public ITestServerService
{
public:
	// This is a sample web service method that shows how to use the 
	// soap_method attribute to expose a method as a web method
	[ soap_method ]
	HRESULT HelloWorld(/*[in]*/ BSTR bstrInput, /*[out, retval]*/ BSTR *bstrOutput)
	{
		CComBSTR bstrOut(L"Hello ");
		bstrOut += bstrInput;
		bstrOut += L"!";
		*bstrOutput = bstrOut.Detach();
		
		// Deliberately adding a Sleep here, to emphasize the async behavior of the client
		Sleep(1000);
		return S_OK;
	}
	// TODO: Add additional web service methods here
}; // class CTestServerService

} // namespace TestServerService
