using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using Common;

namespace ChainedServiceFactory
{
	/// <summary>
	/// 
	/// </summary>
	public class ChainedServiceFactory : System.Web.Services.WebService
	{
		public ChainedServiceFactory()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		[WebMethod]
		public DataSet Execute(DataSet dsData, string sService)		
		{
			DataSet ds = new DataSet();
			Facade oFacade = null;
						
			try
			{
				// call static translator method to extract the service name for this packet
				switch (sService)
				{
					case "Transactor":
						oFacade = (Facade) new TransactorFacade();
						break;
					case "Report":
						oFacade = (Facade) new ReportFacade();
						break;
					default:
						return ds;
				}
			}
			catch (Exception e)
			{
				// need to add web service exception handling here...
				throw new BaseException(this, 100, Utilities.BuildErrorMessage("General Error", e.Message), e, true);
			}
			
			// invoke the factory method on the facade
			ds = oFacade.Execute(dsData); 
			return ds;
		}

	}
}
