// Copyright (c) 2002-2003 Brian Eshelman, EshelTech Consulting.
// All Rights Reserved.  Developed for Dot Net Design Patterns.
// 
// Permission to use, copy, modify, and distribute this 
// software and its documentation for NON-COMMERCIAL purposes
// and without fee is hereby granted provided that this 
// copyright notice appears in all copies. 
//
// THE AUTHOR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT 
// THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR 
// NON-INFRINGEMENT. THE AUTHOR SHALL NOT BE LIABLE FOR ANY 
// DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, 
// MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
// Please send any comments to beshelman@esheltech.com
//

using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TestBed
{
	/// <summary>
	/// Summary description for frmTestCase.
	/// </summary>
	public class frmTestCase : System.Windows.Forms.Form
	{
		public DataSet dsRequestValues = null;
		public CachingTypeLoader Loader = null;

		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtAssembly;
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btnLoad;
		private System.Windows.Forms.ComboBox cboClass;
		private System.Windows.Forms.Button btnSelect;
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btnQuickFill;
		private System.Windows.Forms.TextBox txtQuickFillCount;
		private System.Windows.Forms.Button btnTestCaseLoad;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button btnTestCaseSave;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.TextBox txtInstructions;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmTestCase() 
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.label1 = new System.Windows.Forms.Label();
			this.txtAssembly = new System.Windows.Forms.TextBox();
			this.btnOpen = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.btnLoad = new System.Windows.Forms.Button();
			this.cboClass = new System.Windows.Forms.ComboBox();
			this.btnSelect = new System.Windows.Forms.Button();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.btnClose = new System.Windows.Forms.Button();
			this.btnQuickFill = new System.Windows.Forms.Button();
			this.txtQuickFillCount = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.btnTestCaseLoad = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.btnTestCaseSave = new System.Windows.Forms.Button();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.txtInstructions = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.DefaultExt = "*.dll";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Assembly:";
			// 
			// txtAssembly
			// 
			this.txtAssembly.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtAssembly.Location = new System.Drawing.Point(72, 8);
			this.txtAssembly.Name = "txtAssembly";
			this.txtAssembly.Size = new System.Drawing.Size(264, 20);
			this.txtAssembly.TabIndex = 1;
			this.txtAssembly.Text = "";
			// 
			// btnOpen
			// 
			this.btnOpen.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.btnOpen.Location = new System.Drawing.Point(336, 8);
			this.btnOpen.Name = "btnOpen";
			this.btnOpen.Size = new System.Drawing.Size(24, 20);
			this.btnOpen.TabIndex = 2;
			this.btnOpen.Text = "...";
			this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "Class:";
			// 
			// btnLoad
			// 
			this.btnLoad.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.btnLoad.Location = new System.Drawing.Point(368, 8);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.Size = new System.Drawing.Size(48, 20);
			this.btnLoad.TabIndex = 4;
			this.btnLoad.Text = "Load";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
			// 
			// cboClass
			// 
			this.cboClass.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.cboClass.Location = new System.Drawing.Point(72, 32);
			this.cboClass.Name = "cboClass";
			this.cboClass.Size = new System.Drawing.Size(288, 21);
			this.cboClass.TabIndex = 5;
			this.cboClass.Text = "<please load an assembly>";
			// 
			// btnSelect
			// 
			this.btnSelect.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.btnSelect.Location = new System.Drawing.Point(368, 32);
			this.btnSelect.Name = "btnSelect";
			this.btnSelect.Size = new System.Drawing.Size(48, 20);
			this.btnSelect.TabIndex = 6;
			this.btnSelect.Text = "Select";
			this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
			// 
			// dataGrid1
			// 
			this.dataGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 56);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(424, 320);
			this.dataGrid1.TabIndex = 7;
			this.dataGrid1.CurrentCellChanged += new System.EventHandler(this.dataGrid1_CurrentCellChanged);
			// 
			// btnClose
			// 
			this.btnClose.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.btnClose.Location = new System.Drawing.Point(344, 384);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(75, 20);
			this.btnClose.TabIndex = 8;
			this.btnClose.Text = "Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// btnQuickFill
			// 
			this.btnQuickFill.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.btnQuickFill.Location = new System.Drawing.Point(264, 384);
			this.btnQuickFill.Name = "btnQuickFill";
			this.btnQuickFill.Size = new System.Drawing.Size(64, 20);
			this.btnQuickFill.TabIndex = 11;
			this.btnQuickFill.Text = "Quick Fill";
			this.btnQuickFill.Click += new System.EventHandler(this.btnQuickFill_Click);
			// 
			// txtQuickFillCount
			// 
			this.txtQuickFillCount.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.txtQuickFillCount.Location = new System.Drawing.Point(208, 384);
			this.txtQuickFillCount.Name = "txtQuickFillCount";
			this.txtQuickFillCount.Size = new System.Drawing.Size(56, 20);
			this.txtQuickFillCount.TabIndex = 10;
			this.txtQuickFillCount.Text = "10";
			// 
			// label3
			// 
			this.label3.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.label3.Location = new System.Drawing.Point(168, 384);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 16);
			this.label3.TabIndex = 9;
			this.label3.Text = "Count:";
			// 
			// btnTestCaseLoad
			// 
			this.btnTestCaseLoad.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.btnTestCaseLoad.Location = new System.Drawing.Point(72, 384);
			this.btnTestCaseLoad.Name = "btnTestCaseLoad";
			this.btnTestCaseLoad.Size = new System.Drawing.Size(40, 20);
			this.btnTestCaseLoad.TabIndex = 4;
			this.btnTestCaseLoad.Text = "Load";
			this.btnTestCaseLoad.Click += new System.EventHandler(this.btnTestCaseLoad_Click);
			// 
			// label4
			// 
			this.label4.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.label4.Location = new System.Drawing.Point(8, 384);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(64, 16);
			this.label4.TabIndex = 0;
			this.label4.Text = "Test Case:";
			// 
			// btnTestCaseSave
			// 
			this.btnTestCaseSave.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.btnTestCaseSave.Location = new System.Drawing.Point(112, 384);
			this.btnTestCaseSave.Name = "btnTestCaseSave";
			this.btnTestCaseSave.Size = new System.Drawing.Size(40, 20);
			this.btnTestCaseSave.TabIndex = 4;
			this.btnTestCaseSave.Text = "Save";
			this.btnTestCaseSave.Click += new System.EventHandler(this.btnTestCaseSave_Click);
			// 
			// openFileDialog2
			// 
			this.openFileDialog2.DefaultExt = "*.testCase";
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "*.testCase";
			this.saveFileDialog1.FileName = "doc1";
			// 
			// txtInstructions
			// 
			this.txtInstructions.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtInstructions.Location = new System.Drawing.Point(8, 88);
			this.txtInstructions.Multiline = true;
			this.txtInstructions.Name = "txtInstructions";
			this.txtInstructions.Size = new System.Drawing.Size(400, 272);
			this.txtInstructions.TabIndex = 12;
			this.txtInstructions.Text = "";
			// 
			// frmTestCase
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 406);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.txtInstructions,
																		  this.btnQuickFill,
																		  this.txtQuickFillCount,
																		  this.label3,
																		  this.btnClose,
																		  this.dataGrid1,
																		  this.btnSelect,
																		  this.cboClass,
																		  this.btnLoad,
																		  this.label2,
																		  this.btnOpen,
																		  this.txtAssembly,
																		  this.label1,
																		  this.btnTestCaseLoad,
																		  this.label4,
																		  this.btnTestCaseSave});
			this.Name = "frmTestCase";
			this.Text = "Test Case";
			this.Load += new System.EventHandler(this.frmTestCase_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOpen_Click(object sender, System.EventArgs e)
		{
			try
			{
				openFileDialog1.FileName = txtAssembly.Text;

				if (openFileDialog1.ShowDialog(this) == DialogResult.OK)
				{
					txtAssembly.Text = openFileDialog1.FileName;
					if (txtAssembly.Text.Length > 0)
						btnLoad_Click(null, null);
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}

		}

		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			try
			{
				cboClass.Text = "";
				cboClass.Items.Clear();
				txtInstructions.Visible = false;

				IList aTypes = Loader.LoadTypeList(txtAssembly.Text, "ITestable");
				foreach (System.Type type in aTypes)
				{
					cboClass.Items.Add(type.ToString());
				}

				if (cboClass.Items.Count > 0)
					cboClass.SelectedIndex = 0;
			
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void btnSelect_Click(object sender, System.EventArgs e)
		{
			DataTable tblDefinition = GetValuesTable();
			
			try
			{
				TestBed.ITestable iface = GetTestObject();
				
				// Add the assembly and class columns if they do not already exist
				if (tblDefinition.Columns["Assembly"] == null)
					tblDefinition.Columns.Add("Assembly", typeof(string));
				if (tblDefinition.Columns["Class"] == null)
					tblDefinition.Columns.Add("Class", typeof(string));
				// Set the defaults for both
				tblDefinition.Columns["Assembly"].DefaultValue = txtAssembly.Text;
				tblDefinition.Columns["Class"].DefaultValue = cboClass.Text;

				System.Collections.SortedList list = iface.GetTestParameters();
				//tblDefinition.Columns.Clear();
				foreach (object oKey in list)
				{
					System.Collections.DictionaryEntry key = (System.Collections.DictionaryEntry)oKey;
					//tblDefinition.Columns.Add(key.Key as string, key.Value as System.Type);
					if (tblDefinition.Columns[key.Key as string] == null)
						tblDefinition.Columns.Add(key.Key as string, key.Value as System.Type);

				}

				dataGrid1.DataSource = tblDefinition;

				DataRow row = GetDefinitionRow();
				row["Assembly"] = txtAssembly.Text;
				row["Class"] = cboClass.Text;
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		
		}

		private void btnQuickFill_Click(object sender, System.EventArgs e)
		{
			int nCount = 0;
			try
			{
				nCount = int.Parse(txtQuickFillCount.Text);
			}
			catch
			{
				return;
			}

			try
			{
				DataTable tblDefinition = GetValuesTable();
				TestBed.ITestable iface = GetTestObject();

				System.Collections.SortedList[] alist = iface.GetTestSet(nCount);

				foreach (System.Collections.SortedList list in alist)
				{
					DataRow row = tblDefinition.NewRow();

					foreach (object oKey in list)
					{
						System.Collections.DictionaryEntry key = (System.Collections.DictionaryEntry)oKey;
						
						row[key.Key as string] = key.Value;
					}

					tblDefinition.Rows.Add(row);
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private TestBed.ITestable GetTestObject()
		{
			System.Type type = Loader.LoadType(txtAssembly.Text, cboClass.Items[cboClass.SelectedIndex].ToString());
			System.Reflection.ConstructorInfo constructor = type.GetConstructor(System.Type.EmptyTypes);
			TestBed.ITestable iface = constructor.Invoke(System.Type.EmptyTypes) as TestBed.ITestable;
			return iface;
		}

		private DataTable GetValuesTable()
		{
			DataTable tblDefinition = dsRequestValues.Tables["RequestValues"];
			if (tblDefinition == null)
				tblDefinition = dsRequestValues.Tables.Add("RequestValues");
			return tblDefinition;
		}

		private DataRow GetDefinitionRow()
		{
			DataTable tblDefinition = dsRequestValues.Tables["TestDefinition"];
			DataRow row = null;
			if (tblDefinition == null)
			{
				tblDefinition = dsRequestValues.Tables.Add("TestDefinition");
				tblDefinition.Columns.Add("Assembly", typeof(string));
				tblDefinition.Columns.Add("Class", typeof(string));
				
				row = tblDefinition.NewRow();
				row["Assembly"] = "";
				row["Class"] = "";
				tblDefinition.Rows.Add(row);
			}
			else
			{
				row = tblDefinition.Rows[0];
			}

			return row;
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnTestCaseLoad_Click(object sender, System.EventArgs e)
		{
			try
			{
				dsRequestValues.Dispose();
				dsRequestValues = new DataSet("RequestValues");

				openFileDialog2.ShowDialog(this);
				dsRequestValues.ReadXml(openFileDialog2.FileName);

				DataRow row = GetDefinitionRow();
				txtAssembly.Text = row["Assembly"] as string;
				btnLoad_Click(null, null);
				
				cboClass.SelectedText = row["Class"] as string;

				DataTable tblDefinition = GetValuesTable();
				dataGrid1.DataSource = tblDefinition;
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void btnTestCaseSave_Click(object sender, System.EventArgs e)
		{
			try
			{
				saveFileDialog1.ShowDialog(this);
				dsRequestValues.WriteXml(saveFileDialog1.FileName);
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}

		}

		private void frmTestCase_Load(object sender, System.EventArgs e)
		{
			txtInstructions.Text = "Instructions for Use:\r\n1.	Enter an assembly name or use the button to search for one\r\n2.	Click Load to load the ITestable classes into the Class list\r\n3.	Select a class to test and click Select to load the test parameters\r\n4.	Either manually enter test cases or use the Quick Fill below to pre-populate the specified number of cases.\r\n5.	Save your test case to a file for future use.\r\n\r\nOR\r\n1.	Click Load to load a previously created test case\r\n";
			txtInstructions.Visible = true;
			txtInstructions.ReadOnly = true;

		}

		private void dataGrid1_CurrentCellChanged(object sender, System.EventArgs e)
		{
			System.Diagnostics.Debug.WriteLine(e);
			System.Diagnostics.Debug.WriteLine(sender);
		}
	}
}
