using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Net;
using System.Configuration;

namespace RemoteTracer
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class RemoteTracerService : System.Web.Services.WebService
	{
		public RemoteTracerService()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		// WEB SERVICE EXAMPLE
		// The HelloWorld() example service returns the string Hello World
		// To build, uncomment the following lines then save and build the project
		// To test this web service, press F5

//		[WebMethod]
//		public string HelloWorld()
//		{
//			return "Hello World";
//		}

		/// <summary>
		/// Called by external clients to send all remote traces into the central services
		/// </summary>
		[WebMethod]
		public void RemoteTrace(string sSource, string sMessage)
		{
			EventLog oElog = new EventLog("Application", Dns.GetHostName(), "RemoteTracer");
			
			try
			{
				// first send it to the trace queue, queue should create itself if has been deleted
				Messenger oMessenger = new Messenger();
				BusinessMessage oMessage = oMessenger.MessageInfo;
				
				oMessage.MessageText = sMessage;
				oMessage.Uri = Context.Request.UserHostName;	// uri of the requesting party, this is the host name
				oMessage.UserId = sSource;						// the source should be the user
				oMessage.Date = DateTime.Now.ToShortDateString();
				oMessage.Time = DateTime.Now.ToShortTimeString();

				// must set the message type we are looking for, this looks in the correct queue
				oMessage.MessageType = "trace";
				
				// send the trace to the queue
				oMessenger.Send(oMessage);

				// next send it a socket stream
				// This will come from the configuration agent based on the source string
				// the source string should later be passed to config agent and an IP address should be returned
				string sRemoteTraceTargetHost = ConfigurationSettings.AppSettings["RemoteTraceTarget"];
				//string sIP = Dns.GetHostByName(Dns.GetHostName()).AddressList[0].ToString();
				string sIP = Dns.GetHostByName(sRemoteTraceTargetHost).AddressList[0].ToString();
				int nPort = 8001;
				Utilities.SendSocketStream(sIP, nPort, sSource + ":" + sMessage);
					
			}
			catch (Exception e)
			{
				// or socket server was not listening, either way just log it and move on...
				oElog.WriteEntry(BaseException.Format(null, 0, "RemoteTracer - Error Occured During Remote Message Trace: " + e.Message, e));
				//oElog.WriteEntry("PMRemoteTracer - Error Occured During Remote Message Trace: " + e.ToString());
			}
		}
	}
}
